# Telegram Bot API - PHP SDK

[![Join the PHP Chat community][ico-phpchat]][link-phpchat]

> The (Unofficial) [Telegram Bot API][link-telegram-bots] PHP SDK. Lets you develop Telegram Bots easily! Supports Laravel out of the box.

[![Telegram Bot API PHP SDK][hero-img]][link-author]

<p align="center">
<a href="https://travis-ci.org/irazasyed/telegram-bot-sdk"><img src="https://img.shields.io/travis/irazasyed/telegram-bot-sdk.svg?style=flat-square" alt="Build Status"/></a>
<a href="https://github.com/irazasyed/telegram-bot-sdk/releases"><img src="https://img.shields.io/github/release/irazasyed/telegram-bot-sdk.svg?style=flat-square" alt="Latest Version"/></a>
<a href="https://packagist.org/packages/irazasyed/telegram-bot-sdk"><img src="https://img.shields.io/packagist/dt/irazasyed/telegram-bot-sdk.svg?style=flat-square" alt="Total Downloads"/></a>
</p>

## Overview

> Telegram Bot API is an HTTP-based interface created for developers keen on building bots for Telegram.
>
> To learn more about the Telegram Bot API, please consult the [Introduction to Bots][link-telegram-bots] and [Bot FAQ][link-telegram-bot-faq] on official Telegram site.
>
> To get started writing your bots using this SDK, Please refer the [documentation][link-docs].

## Documentation

Documentation for the SDK can be found on the [website][link-docs].

## Are You Using Telegram Bot SDK?

If you're using this SDK to build your Telegram Bots, We'd love to know and share the bot with the world. Tell us about it - **[here][link-sdk-users]**

Check out the [Who's Using Telegram Bot SDK][link-sdk-users] wiki page to know more about what people have been building with this SDK.

## Additional information

Any issues, feedback, suggestions or questions please use issue tracker [here][link-issues].

## Contributing

Please see [CONTRIBUTING][link-contributing] and [CONDUCT][link-conduct] for details.

## Security

If you discover any security related issues, please email syed at lukonet.com instead of using the issue tracker.

## Credits

- [Syed Irfaq R.][link-author]
- [All Contributors][link-contributors]

## Disclaimer

This project and its author is neither associated, nor affiliated with [Telegram][link-telegram] in anyway.

## License

The [BSD 3-Clause][link-license] License. Please see [License File][link-license] for more information.

[ico-phpchat]: https://img.shields.io/badge/Join-PHP%20Chat-blue.svg?style=flat-square
[hero-img]: https://cloud.githubusercontent.com/assets/1915268/8475216/fe774802-20d3-11e5-9692-f54502716d64.png

[link-phpchat]: https://telegram-bot-sdk.readme.io/blog/join-php-chat-slack-community-for-support
[link-author]: https://github.com/irazasyed
[link-repo]: https://github.com/irazasyed/telegram-bot-sdk
[link-issues]: ../../issues
[link-contributors]: ../../contributors
[link-conduct]: CONDUCT.md
[link-license]: LICENSE.md
[link-sdk-users]: ../../wiki/Who's-Using-Telegram-Bot-SDK%3F
[link-telegram]: https://telegram.org/
[link-telegram-bots]: https://core.telegram.org/bots
[link-telegram-bot-faq]: https://core.telegram.org/bots/faq
[link-docs]: https://telegram-bot-sdk.readme.io/docs
[link-contributing]: https://telegram-bot-sdk.readme.io/docs/contributing
